/*
 * Copyright (c) 2016,2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU Affero General
 *     Public License as published by the Free Software Foundation,
 *     either version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU Affero General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU Affero General
 *     Public License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef DATAFRAME_SKIP_BLANK_LINES_HPP
#define DATAFRAME_SKIP_BLANK_LINES_HPP 1

#include <dataframe/manipulator_storage_base.hpp>

namespace dataframe
{

  class skip_bl
    : public manipulator_storage_base< skip_bl >
  {
    using base = manipulator_storage_base< skip_bl >;
    
  public:
    template < typename ... Args >
    skip_bl (Args&& ... args)
      : base(std::forward<Args>(args)...)
    {}
  };

  auto skip_blank_lines (std::ios_base& ios_base) { return skip_bl(ios_base); }
  auto skip_blank_lines (bool flag) { return skip_bl(flag); }
  auto skip_blank_lines () { return skip_blank_lines(true); }
  
} // namespace dataframe

#endif
