/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU Affero General
 *     Public License as published by the Free Software Foundation,
 *     either version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU Affero General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU Affero General
 *     Public License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_CONCEPT_EVAL_CONCEPT_HPP
#define GRAPH_MODEL_CONCEPT_EVAL_CONCEPT_HPP 1

#include <boost/concept_check.hpp>

namespace graph_model
{

  namespace concept
  {

    template < typename T >
    class eval_concept
    {
      using result_type = typename T::result_type;

    public:      
      BOOST_CONCEPT_USAGE(eval_concept)
      {
	result_ = t_();
	result_ = t_.eval();
      }

    private:
      T const t_;
      result_type result_;
    };

  } // namespace concept

} // namespace graph_model

#endif
