/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU Affero General
 *     Public License as published by the Free Software Foundation,
 *     either version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU Affero General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU Affero General
 *     Public License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_CONCEPT_VERTEX_ARCHETYPE_BASE_HPP
#define GRAPH_MODEL_CONCEPT_VERTEX_ARCHETYPE_BASE_HPP 1

#include <graph_model/concept/category_archetype.hpp>
#include <graph_model/concept/identifier_archetype.hpp>
#include <graph_model/concept/identifier_archetype_base.hpp>
#include <graph_model/concept/type/category_archetype_base.hpp>
#include <graph_model/concept/vertex_category_archetype.hpp>
#include <graph_model/concept/vertex_category_archetype_base.hpp>

namespace graph_model
{

  namespace concept
  {

    template < typename Category
	       , typename Identifier
	       , typename VertexCategory
	       >
    struct vertex_archetype_base
      : virtual type::category_archetype_base<Category>
      , identifier_archetype_base<Identifier>
      , vertex_category_archetype_base<VertexCategory>
    {};

  } // namespace concept

} // namespace graph_model

#endif
