/*
 * Copyright (c) 2016,2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU Affero General
 *     Public License as published by the Free Software Foundation,
 *     either version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU Affero General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU Affero General
 *     Public License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_TRAITS_EDGE_DESCRIPTOR_HPP
#define GRAPH_MODEL_TRAITS_EDGE_DESCRIPTOR_HPP 1

#include <graph_model/traits/vertex_descriptor.hpp>
#include <graph_model/edge/edge_descriptor.hpp>

namespace graph_model
{

  namespace traits
  {

    template < typename GraphTag >
    struct edge_descriptor
    {
      using type = ::graph_model::edge::edge_descriptor<vertex_descriptor_t<GraphTag>>;
    };

    template < typename GraphTag >
    using edge_descriptor_t = typename edge_descriptor<GraphTag>::type;

  } // namespace traits

} // namespace graph_model

#endif
