/*
 * Copyright (c) 2016,2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU Affero General
 *     Public License as published by the Free Software Foundation,
 *     either version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU Affero General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU Affero General
 *     Public License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_TRAITS_VERTEX_OBSERVER_COLLECTION_HPP
#define GRAPH_MODEL_TRAITS_VERTEX_OBSERVER_COLLECTION_HPP 1

#include <graph_model/traits/vertex.hpp>
#include <graph_model/vertex/observer_collection.hpp>

namespace graph_model
{

  namespace traits
  {

    template < typename GraphTag >
    class vertex_observer_collection
    {
      using vertex_type = vertex_t<GraphTag>;
      using vertex_observer_collection_type = ::graph_model::vertex::observer_collection<vertex_type const>;
    public:
      using type = vertex_observer_collection_type;
    };

    template < typename GraphTag >
    using vertex_observer_collection_t = typename vertex_observer_collection<GraphTag>::type;

  } // namespace traits

} // namespace graph_model

#endif
