/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU Affero General
 *     Public License as published by the Free Software Foundation,
 *     either version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU Affero General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU Affero General
 *     Public License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_VERTEX_SCALAR_DISTRIBUTION_IMPL_BASE_HPP
#define GRAPH_MODEL_VERTEX_SCALAR_DISTRIBUTION_IMPL_BASE_HPP 1

#include <graph_model/vertex/cdf_impl_base.hpp>
#include <graph_model/vertex/distribution_impl_base.hpp>

namespace graph_model
{

  namespace vertex
  {

    template < typename Derived, typename Category, typename Variate, typename Base >
    struct scalar_distribution_impl_base
      : cdf_impl_base<Derived,Variate
      , distribution_impl_base<Derived,Category
      , Base
      > >
    {};

  } // namespace vertex

} // namespace graph_model

#endif
