/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU Affero General
 *     Public License as published by the Free Software Foundation,
 *     either version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU Affero General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU Affero General
 *     Public License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef LOGGING_LOGGING_STATUS_HPP
#define LOGGING_LOGGING_STATUS_HPP 1

#include <boost/log/core.hpp>

namespace logging
{

  struct logging_status
  {
    static auto apply () { boost::log::core::get()->set_logging_enabled(status_()); }
    static void apply (bool flag) { status_() = flag; }

  private:
    static bool& status_ () { static bool status = false; return status; }
  };

  void enable () { logging_status::apply(true); }
  void disable () { logging_status::apply(false); }

} // namespace logging

#endif
