/*
 * Copyright (c) 2016,2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU Affero General
 *     Public License as published by the Free Software Foundation,
 *     either version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU Affero General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU Affero General
 *     Public License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef TRAITS_MAPPED_TYPE_HPP
#define TRAITS_MAPPED_TYPE_HPP 1

#include <map>

namespace traits
{

  template < typename T >
  class mapped_type;

  template < typename Key, typename Value, typename Alloc >
  struct mapped_type< std::map<Key,Value,Alloc> >
  {
    using type = Value;
  };

  template < typename T >
  using mapped_type_t = typename mapped_type<T>::type;
  
} // namespace traits

#endif
